unit RegU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Grids;

type
  TForm1 = class(TForm)
    SG: TStringGrid;
    List: TListBox;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  Registry;

{$R *.DFM}

const
  CompLib = 'CmpLib32.Dcl.Palette';
  EngineRepository = 'Software\Borland\Database Engine\Settings\Repositories';
  DataDictionary = 'Sample Data Dictionary';

procedure TForm1.FormCreate(Sender: TObject);
var
  Ini: TRegIniFile;
  Loop, Loop2, P: Integer;
  Entry: String;
begin
  with SG, List, TRegIniFile.Create('Software\Borland\Delphi\2.0') do
    try
      { Get all palette page names }
      ReadSection(CompLib, Items);
      { Make sure there are enough columns in grid }
      ColCount := Items.Count;
      for Loop := 0 to Pred(Items.Count) do
      begin
        { Write palette page on top row of grid }
        Cells[Loop, 0] := Items[Loop];
        { Get components on this page }
        Entry := ReadString(CompLib, Items[Loop], '');
        Loop2 := 1;
        repeat
          { The components are semicolon seperated }
          P := Pos(';', Entry);
          if P > 0 then
          begin
            { Make sure there are enough rows in grid }
            if RowCount = Loop2 then
              RowCount := Loop2 + 1;
            Cells[Loop, Loop2] := Copy(Entry, 1, P-1);
            Delete(Entry, 1, P);
          end;
          Inc(Loop2);
        until P = 0;
      end;
    finally
      Free;
    end;
  { Write database name and table name of }
  { default BDE data dictionary on caption }
  with TRegIniFile.Create(''), SG, List do
    try
      RootKey := HKEY_LOCAL_MACHINE;
      OpenKey(EngineRepository, False);
      Caption :=
        ReadString(DataDictionary, 'Database Name', '<not set>') + ':' +
        ReadString(DataDictionary, 'Table Name', '<not set>');
    finally
      Free;
    end;
end;

end.
